// This file lists the error messages for WinTim32

#define WTERR_NOERROR					0x0000

// disruptive errors (parsing cannot continue)
#define WTERR_NEWLINEINSTRING			0x0101
#define WTERR_NOSTRINGHEADER			0x0102
#define WTERR_MACROWITHOUTENDM			0x0103
#define WTERR_ILLEGALCHARACTER			0x0104
#define WTERR_ARGANDCOMMAONLY			0x0105
#define WTERR_NOCOMMAAFTERARG			0x0106
#define WTERR_UNTERMINATEDSTRING		0x0107
#define WTERR_STACKOVERFLOW				0x0108
#define WTERR_INVALIDNEWORIGIN			0x0109
#define WTERR_MAXRECURSION				0x010a
#define WTERR_INCLUDEFAILED				0x010b
#define WTERR_ELSEWITHOUTIF				0x010c

// nondisruptive errors (parsing can continue)
#define WTERR_NONDISRUPTIVE				0x1000
#define WTERR_UNEXPECTEDTOKEN			0x1001
#define WTERR_INVALIDNUMBER				0x1002
#define WTERR_NOLABEL					0x1004
#define WTERR_NOSYMBOL					0x1005
#define WTERR_NOOPERATOR				0x1006
#define WTERR_EXPECTEDBASE				0x1007
#define WTERR_INVALIDBASE				0x1008
#define WTERR_BASEWITHOUTNUM			0x1009
#define WTERR_INVALIDBINARY				0x100a
#define WTERR_INVALIDOCTAL				0x100b
#define WTERR_INVALIDDECIMAL			0x100c
#define WTERR_INVALIDHEX				0x100d
#define WTERR_ILLEGALTOKENINEXPR		0x100e
#define WTERR_UNDEFINEDORG				0x100f
#define WTERR_UNRECOGNIZEDTOKEN			0x1010
#define WTERR_NOTENOUGHARGS				0x1011
#define WTERR_UNDEFINEDLABEL			0x1012
#define WTERR_DUPLICATELABEL			0x1013
#define WTERR_MULTIPLEVARS				0x1014
#define WTERR_VARAFTERTWONUMS			0x1015
#define WTERR_INTERNALMACROINCONS		0x1016
#define WTERR_PARENMISMATCH				0x1017
#define WTERR_MULTIPLEOPS				0x1018
#define WTERR_OPATENDLINE				0x1019
#define WTERR_OPBEFOREEXPR				0x101a
#define WTERR_TOOMANYARGS				0x101b
#define WTERR_LBRACKETNOTFIRST			0x101c
#define WTERR_EXTRARBRACKET				0x101d
#define WTERR_TRASHAFTERRBRACKET		0x101e
#define WTERR_UNDEFINEDALIGN			0x101f
#define WTERR_INVALIDIF					0x1020
#define WTERR_IFWITHOUTENDIF			0x1021

// warnings (does not prevent assembly)
#define WTWARN_NOWARN					0x4000
#define WTWARN_ENDBEFOREEOF				0x4001
#define WTWARN_DEFINASM					0x4002
#define WTWARN_FIELDLENGTHDISCREPANCY	0x4003
#define WTWARN_MICROWORDLENGTH			0x4004
#define WTWARN_COMMAATENDOFDEF			0x4005
#define WTWARN_NOBITLENGTH				0x4006
#define WTWARN_FORMDISCREPANCY			0x4007
#define WTWARN_INVALIDLISTOPTION		0x4008
#define WTWARN_CANNOTSKIP				0x4009
#define WTWARN_NOTENOUGHARGS			0x400a

// notices (not necessarily incorrect code)
#define WTNOTE_NONOTE					0x5000

#define WTERR_LAST